<a id="types-aiobotocore-apigatewayv2"></a>

# types-aiobotocore-apigatewayv2

[![PyPI - types-aiobotocore-apigatewayv2](https://img.shields.io/pypi/v/types-aiobotocore-apigatewayv2.svg?color=blue)](https://pypi.org/project/types-aiobotocore-apigatewayv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-apigatewayv2.svg?color=blue)](https://pypi.org/project/types-aiobotocore-apigatewayv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-apigatewayv2?color=blue)](https://pypistats.org/packages/types-aiobotocore-apigatewayv2)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.ApiGatewayV2 2.3.3](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/apigatewayv2.html#ApiGatewayV2)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.6.1](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-apigatewayv2 docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_apigatewayv2/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-apigatewayv2](#types-aiobotocore-apigatewayv2)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `ApiGatewayV2`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `ApiGatewayV2` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[apigatewayv2]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[apigatewayv2]'


# standalone installation
python -m pip install types-aiobotocore-apigatewayv2
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-apigatewayv2
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[apigatewayv2]` in your environment:

```bash
python -m pip install 'types-aiobotocore[apigatewayv2]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[apigatewayv2]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[apigatewayv2]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[apigatewayv2]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[apigatewayv2]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[apigatewayv2]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[apigatewayv2]` in your environment:

```bash
python -m pip install 'types-aiobotocore[apigatewayv2]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[apigatewayv2]` in your environment:

```bash
python -m pip install 'types-aiobotocore[apigatewayv2]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ApiGatewayV2Client` provides annotations for
`session.create_client("apigatewayv2")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_apigatewayv2 import ApiGatewayV2Client

session = get_session()
async with session.create_client("apigatewayv2") as client:
    client: ApiGatewayV2Client
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_apigatewayv2.paginator` module contains type annotations for
all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_apigatewayv2 import ApiGatewayV2Client
from types_aiobotocore_apigatewayv2.paginator import (
    GetApisPaginator,
    GetAuthorizersPaginator,
    GetDeploymentsPaginator,
    GetDomainNamesPaginator,
    GetIntegrationResponsesPaginator,
    GetIntegrationsPaginator,
    GetModelsPaginator,
    GetRouteResponsesPaginator,
    GetRoutesPaginator,
    GetStagesPaginator,
)

session = get_session()
async with session.create_client("apigatewayv2") as client:
    client: ApiGatewayV2Client

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        get_apis_paginator: GetApisPaginator = client.get_paginator("get_apis")
        get_authorizers_paginator: GetAuthorizersPaginator = client.get_paginator("get_authorizers")
        get_deployments_paginator: GetDeploymentsPaginator = client.get_paginator("get_deployments")
        get_domain_names_paginator: GetDomainNamesPaginator = client.get_paginator("get_domain_names")
        get_integration_responses_paginator: GetIntegrationResponsesPaginator = client.get_paginator("get_integration_responses")
        get_integrations_paginator: GetIntegrationsPaginator = client.get_paginator("get_integrations")
        get_models_paginator: GetModelsPaginator = client.get_paginator("get_models")
        get_route_responses_paginator: GetRouteResponsesPaginator = client.get_paginator("get_route_responses")
        get_routes_paginator: GetRoutesPaginator = client.get_paginator("get_routes")
        get_stages_paginator: GetStagesPaginator = client.get_paginator("get_stages")
    ```







### Literals

`types_aiobotocore_apigatewayv2.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_apigatewayv2.literals import (
    AuthorizationTypeType,
    AuthorizerTypeType,
    ConnectionTypeType,
    ContentHandlingStrategyType,
    DeploymentStatusType,
    DomainNameStatusType,
    EndpointTypeType,
    GetApisPaginatorName,
    GetAuthorizersPaginatorName,
    GetDeploymentsPaginatorName,
    GetDomainNamesPaginatorName,
    GetIntegrationResponsesPaginatorName,
    GetIntegrationsPaginatorName,
    GetModelsPaginatorName,
    GetRouteResponsesPaginatorName,
    GetRoutesPaginatorName,
    GetStagesPaginatorName,
    IntegrationTypeType,
    JSONYAMLType,
    LoggingLevelType,
    OAS30Type,
    PassthroughBehaviorType,
    ProtocolTypeType,
    SecurityPolicyType,
    VpcLinkStatusType,
    VpcLinkVersionType,
    ApiGatewayV2ServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)

def check_value(value: AuthorizationTypeType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_apigatewayv2.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_apigatewayv2.type_defs import (
    AccessLogSettingsTypeDef,
    ApiMappingTypeDef,
    CorsTypeDef,
    JWTConfigurationTypeDef,
    CreateApiMappingRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    CreateDeploymentRequestRequestTypeDef,
    DomainNameConfigurationTypeDef,
    MutualTlsAuthenticationInputTypeDef,
    MutualTlsAuthenticationTypeDef,
    TlsConfigInputTypeDef,
    CreateIntegrationResponseRequestRequestTypeDef,
    TlsConfigTypeDef,
    CreateModelRequestRequestTypeDef,
    ParameterConstraintsTypeDef,
    RouteSettingsTypeDef,
    CreateVpcLinkRequestRequestTypeDef,
    DeleteAccessLogSettingsRequestRequestTypeDef,
    DeleteApiMappingRequestRequestTypeDef,
    DeleteApiRequestRequestTypeDef,
    DeleteAuthorizerRequestRequestTypeDef,
    DeleteCorsConfigurationRequestRequestTypeDef,
    DeleteDeploymentRequestRequestTypeDef,
    DeleteDomainNameRequestRequestTypeDef,
    DeleteIntegrationRequestRequestTypeDef,
    DeleteIntegrationResponseRequestRequestTypeDef,
    DeleteModelRequestRequestTypeDef,
    DeleteRouteRequestParameterRequestRequestTypeDef,
    DeleteRouteRequestRequestTypeDef,
    DeleteRouteResponseRequestRequestTypeDef,
    DeleteRouteSettingsRequestRequestTypeDef,
    DeleteStageRequestRequestTypeDef,
    DeleteVpcLinkRequestRequestTypeDef,
    DeploymentTypeDef,
    ExportApiRequestRequestTypeDef,
    GetApiMappingRequestRequestTypeDef,
    GetApiMappingsRequestRequestTypeDef,
    GetApiRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    GetApisRequestRequestTypeDef,
    GetAuthorizerRequestRequestTypeDef,
    GetAuthorizersRequestRequestTypeDef,
    GetDeploymentRequestRequestTypeDef,
    GetDeploymentsRequestRequestTypeDef,
    GetDomainNameRequestRequestTypeDef,
    GetDomainNamesRequestRequestTypeDef,
    GetIntegrationRequestRequestTypeDef,
    GetIntegrationResponseRequestRequestTypeDef,
    GetIntegrationResponsesRequestRequestTypeDef,
    IntegrationResponseTypeDef,
    GetIntegrationsRequestRequestTypeDef,
    GetModelRequestRequestTypeDef,
    GetModelTemplateRequestRequestTypeDef,
    GetModelsRequestRequestTypeDef,
    ModelTypeDef,
    GetRouteRequestRequestTypeDef,
    GetRouteResponseRequestRequestTypeDef,
    GetRouteResponsesRequestRequestTypeDef,
    GetRoutesRequestRequestTypeDef,
    GetStageRequestRequestTypeDef,
    GetStagesRequestRequestTypeDef,
    GetTagsRequestRequestTypeDef,
    GetVpcLinkRequestRequestTypeDef,
    GetVpcLinksRequestRequestTypeDef,
    VpcLinkTypeDef,
    ImportApiRequestRequestTypeDef,
    ReimportApiRequestRequestTypeDef,
    ResetAuthorizersCacheRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateApiMappingRequestRequestTypeDef,
    UpdateDeploymentRequestRequestTypeDef,
    UpdateIntegrationResponseRequestRequestTypeDef,
    UpdateModelRequestRequestTypeDef,
    UpdateVpcLinkRequestRequestTypeDef,
    ApiTypeDef,
    CreateApiRequestRequestTypeDef,
    UpdateApiRequestRequestTypeDef,
    AuthorizerTypeDef,
    CreateAuthorizerRequestRequestTypeDef,
    UpdateAuthorizerRequestRequestTypeDef,
    CreateApiMappingResponseTypeDef,
    CreateApiResponseTypeDef,
    CreateAuthorizerResponseTypeDef,
    CreateDeploymentResponseTypeDef,
    CreateIntegrationResponseResponseTypeDef,
    CreateModelResponseTypeDef,
    CreateVpcLinkResponseTypeDef,
    EmptyResponseMetadataTypeDef,
    ExportApiResponseTypeDef,
    GetApiMappingResponseTypeDef,
    GetApiMappingsResponseTypeDef,
    GetApiResponseTypeDef,
    GetAuthorizerResponseTypeDef,
    GetDeploymentResponseTypeDef,
    GetIntegrationResponseResponseTypeDef,
    GetModelResponseTypeDef,
    GetModelTemplateResponseTypeDef,
    GetTagsResponseTypeDef,
    GetVpcLinkResponseTypeDef,
    ImportApiResponseTypeDef,
    ReimportApiResponseTypeDef,
    UpdateApiMappingResponseTypeDef,
    UpdateApiResponseTypeDef,
    UpdateAuthorizerResponseTypeDef,
    UpdateDeploymentResponseTypeDef,
    UpdateIntegrationResponseResponseTypeDef,
    UpdateModelResponseTypeDef,
    UpdateVpcLinkResponseTypeDef,
    CreateDomainNameRequestRequestTypeDef,
    UpdateDomainNameRequestRequestTypeDef,
    CreateDomainNameResponseTypeDef,
    DomainNameTypeDef,
    GetDomainNameResponseTypeDef,
    UpdateDomainNameResponseTypeDef,
    CreateIntegrationRequestRequestTypeDef,
    UpdateIntegrationRequestRequestTypeDef,
    CreateIntegrationResultTypeDef,
    GetIntegrationResultTypeDef,
    IntegrationTypeDef,
    UpdateIntegrationResultTypeDef,
    CreateRouteRequestRequestTypeDef,
    CreateRouteResponseRequestRequestTypeDef,
    CreateRouteResponseResponseTypeDef,
    CreateRouteResultTypeDef,
    GetRouteResponseResponseTypeDef,
    GetRouteResultTypeDef,
    RouteResponseTypeDef,
    RouteTypeDef,
    UpdateRouteRequestRequestTypeDef,
    UpdateRouteResponseRequestRequestTypeDef,
    UpdateRouteResponseResponseTypeDef,
    UpdateRouteResultTypeDef,
    CreateStageRequestRequestTypeDef,
    CreateStageResponseTypeDef,
    GetStageResponseTypeDef,
    StageTypeDef,
    UpdateStageRequestRequestTypeDef,
    UpdateStageResponseTypeDef,
    GetDeploymentsResponseTypeDef,
    GetApisRequestGetApisPaginateTypeDef,
    GetAuthorizersRequestGetAuthorizersPaginateTypeDef,
    GetDeploymentsRequestGetDeploymentsPaginateTypeDef,
    GetDomainNamesRequestGetDomainNamesPaginateTypeDef,
    GetIntegrationResponsesRequestGetIntegrationResponsesPaginateTypeDef,
    GetIntegrationsRequestGetIntegrationsPaginateTypeDef,
    GetModelsRequestGetModelsPaginateTypeDef,
    GetRouteResponsesRequestGetRouteResponsesPaginateTypeDef,
    GetRoutesRequestGetRoutesPaginateTypeDef,
    GetStagesRequestGetStagesPaginateTypeDef,
    GetIntegrationResponsesResponseTypeDef,
    GetModelsResponseTypeDef,
    GetVpcLinksResponseTypeDef,
    GetApisResponseTypeDef,
    GetAuthorizersResponseTypeDef,
    GetDomainNamesResponseTypeDef,
    GetIntegrationsResponseTypeDef,
    GetRouteResponsesResponseTypeDef,
    GetRoutesResponseTypeDef,
    GetStagesResponseTypeDef,
)

def get_structure() -> AccessLogSettingsTypeDef:
    return {
      ...
    }
```

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

## What's new

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

## Versioning

`types-aiobotocore-apigatewayv2` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_apigatewayv2/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
